Provisioning: MSVC 2017 Build Tools
[mirror/qt/qt5.git] / coin / provisioning / qtci-osx-10.10-x86_64 / android.sh
1 #!/bin/sh
2
3 #############################################################################
4 ##
5 ## Copyright (C) 2016 The Qt Company Ltd.
6 ## Contact: http://www.qt.io/licensing/
7 ##
8 ## This file is part of the test suite of the Qt Toolkit.
9 ##
10 ## $QT_BEGIN_LICENSE:LGPL21$
11 ## Commercial License Usage
12 ## Licensees holding valid commercial Qt licenses may use this file in
13 ## accordance with the commercial license agreement provided with the
14 ## Software or, alternatively, in accordance with the terms contained in
15 ## a written agreement between you and The Qt Company. For licensing terms
16 ## and conditions see http://www.qt.io/terms-conditions. For further
17 ## information use the contact form at http://www.qt.io/contact-us.
18 ##
19 ## GNU Lesser General Public License Usage
20 ## Alternatively, this file may be used under the terms of the GNU Lesser
21 ## General Public License version 2.1 or version 3 as published by the Free
22 ## Software Foundation and appearing in the file LICENSE.LGPLv21 and
23 ## LICENSE.LGPLv3 included in the packaging of this file. Please review the
24 ## following information to ensure the GNU Lesser General Public License
25 ## requirements will be met: https://www.gnu.org/licenses/lgpl.html and
26 ## http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
27 ##
28 ## As a special exception, The Qt Company gives you certain additional
29 ## rights. These rights are described in The Qt Company LGPL Exception
30 ## version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
31 ##
32 ## $QT_END_LICENSE$
33 ##
34 #############################################################################
35
36 # This script install Android sdk and ndk.
37
38 # It also runs update for SDK API level 18, latest SDK tools, latest platform-tools and - build-tools
39
40 # Android 16 is the minimum requirement for Qt 5.7 applications, but we need something more recent than that for building Qt itself.
41 # E.g The Bluetooth features that require Android 18 will disable themselves dynamically when running on an Android 16 device.
42 # That's why we need to use Andoid-18 API version and decision was made to use it also with Qt 5.6.
43
44 set -e
45 targetFolder="/opt/android"
46 baseUrl="http://ci-files01-hki.ci.local/input/android"
47
48 # SDK
49 sdkVersion="android-sdk_r24.4.1-macosx.zip"
50 sdkBuildToolsVersion="24.0.2"
51 sdkApiLevel="android-18"
52 sdkUrl="$baseUrl/$sdkVersion"
53 sdkSha1="85a9cccb0b1f9e6f1f616335c5f07107553840cd"
54 sdkTargetFile="$targetFolder/$sdkVersion"
55 sdkExtract="unzip $sdkTargetFile -d $targetFolder"
56 sdkFolderName="android-sdk-macosx"
57 sdkName="sdk"
58
59 # NDK
60 ndkVersion="android-ndk-r10e-darwin-x86_64.zip"
61 ndkUrl="$baseUrl/$ndkVersion"
62 ndkSha1="6be8598e4ed3d9dd42998c8cb666f0ee502b1294"
63 ndkTargetFile="$targetFolder/$ndkVersion"
64 ndkExtract="unzip $ndkTargetFile -d $targetFolder"
65 ndkFolderName="android-ndk-r10e"
66 ndkName="ndk"
67
68 function InstallAndroidPackage {
69     targetFolder=$1
70     version=$2
71     url=$3
72     sha1=$4
73     targetFile=$5
74     extract=$6
75     folderName=$7
76     name=$8
77
78     sudo curl --retry 5 --retry-delay 10 --retry-max-time 60 $url -o $targetFile || echo "Failed to download '$url' multiple times"
79     shasum $targetFile |grep $sha1 || echo "shasum check failed !"
80     sudo chmod 755 $targetFile
81     sudo $extract || echo "Failed to extract $url"
82     sudo chown -R qt:wheel $targetFolder/$folderName
83     sudo mv $targetFolder/$folderName $targetFolder/$name || echo "Failed to rename $name"
84     sudo rm -fr $targetFolder/$version || echo "Failed to remove $targetFolder/$version"
85 }
86
87 sudo mkdir $targetFolder
88 # Install Android SDK
89 echo "Installing Android SDK version $sdkVersion..."
90 InstallAndroidPackage $targetFolder $sdkVersion $sdkUrl $sdkSha1 $sdkTargetFile "$sdkExtract" $sdkFolderName $sdkName
91
92 # Install Android NDK
93 echo "Installing Android NDK version $ndkVersion..."
94 InstallAndroidPackage $targetFolder $ndkVersion $ndkUrl $ndkSha1 $ndkTargetFile "$ndkExtract" $ndkFolderName $ndkName
95
96 # run update for Android SDK and install SDK API version 18, latest SDK tools, platform-tools and build-tools
97 echo "Running Android SDK update for API version 18, SDK-tools, platform-tools and build-tools-$sdkBuildToolsVersion..."
98 echo "y" |$targetFolder/sdk/tools/android update sdk --no-ui --all --filter $sdkApiLevel,tools,platform-tools,build-tools-$sdkBuildToolsVersion || echo "Failed to run update"
99
100 # For Qt 5.6, we by default require API levels 10, 11, 16 and 18, but we can override this by setting ANDROID_API_VERSION=android-18
101 # From Qt 5.7 forward, if android-16 is not installed, Qt will automatically use more recent one.
102 echo 'export ANDROID_API_VERSION=android-18' >> ~/.bashrc